<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2016 Leo Feyer
 *
 * @license LGPL-3.0+
 */


/**
 * Register the classes
 */
ClassLoader::addClasses(array
(
	// Models
	'Contao\MovieArchiveModel'  => 'system/modules/movie_list/models/MovieArchiveModel.php',
	'Contao\MovieModel'         => 'system/modules/movie_list/models/MovieModel.php',
	'Contao\MovieActorModel'    => 'system/modules/movie_list/models/MovieActorModel.php',
	'Contao\MovieGenreModel'    => 'system/modules/movie_list/models/MovieGenreModel.php',

	// Classes
	'MovieHelper'               => 'system/modules/movie_list/classes/MovieHelper.php',
	'Movie'                     => 'system/modules/movie_list/classes/Movie.php',

	// Modules
	'Contao\ModuleMovieReader'  => 'system/modules/movie_list/modules/ModuleMovieReader.php',
	'ModuleMovieSearch'         => 'system/modules/movie_list/modules/ModuleMovieSearch.php',
	'Contao\ModuleMovieRelated' => 'system/modules/movie_list/modules/ModuleMovieRelated.php',
	'Contao\ModuleMovie'        => 'system/modules/movie_list/modules/ModuleMovie.php',
	'Contao\ModuleMovieList'    => 'system/modules/movie_list/modules/ModuleMovieList.php',
));


/**
 * Register the templates
 */
TemplateLoader::addFiles(array
(
	'mod_movie_empty'  => 'system/modules/movie_list/templates/modules',
	'mod_movielist'    => 'system/modules/movie_list/templates/modules',
	'mod_moviesearch'  => 'system/modules/movie_list/templates/modules',
	'mod_moviereader'  => 'system/modules/movie_list/templates/modules',
	'mod_movierelated' => 'system/modules/movie_list/templates/modules',
	'movie_full'       => 'system/modules/movie_list/templates/movie',
	'movie_simple'     => 'system/modules/movie_list/templates/movie',
	'movie_list'       => 'system/modules/movie_list/templates/movie',
));
