<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2014 Leo Feyer
 *
 * @package   movie_list
 * @author    Fast End Media | Christian Schmidt <schmidt@fast-end-media.de>
 * @license   LGPL
 * @copyright Fast End Media 2014 <http://www.fast-end-media.de>
 */

/**
 * Add palettes to tl_module
 */
$GLOBALS['TL_DCA']['tl_module']['palettes']['movielist']    = '{title_legend},name,headline,type;{config_legend},movie_archives,numberOfItems,movie_featured,perPage,skipFirst,sortBy;{template_legend:hide},movie_template;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';

$GLOBALS['TL_DCA']['tl_module']['palettes']['moviereader']  = '{title_legend},name,headline,type;{config_legend},movie_archives;{template_legend:hide},movie_template;{redirect_legend:hide},jumpTo;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';

//Eventsuche
$GLOBALS['TL_DCA']['tl_module']['palettes']['moviesearch']		= '{title_legend},name,headline,type;{config_legend},movie_archives,movie_featured,perPage,jumpTo;{search_legend:hide},movie_filter;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';

$GLOBALS['TL_DCA']['tl_module']['palettes']['moviecategories']    = '{title_legend},name,headline,type;{config_legend},movie_archives,movie_featured;{template_legend:hide},navigationTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';

$GLOBALS['TL_DCA']['tl_module']['palettes']['movierelated'] = '{title_legend},name,type,headline;{config_legend:hide},movie_archives,related_numberOfItems,sortBy;{template_legend:hide},movie_template;{expert_legend},align,space,cssID';

/**
 * Add fields to tl_module
 */
$GLOBALS['TL_DCA']['tl_module']['fields']['movie_archives'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_archives'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'options_callback'        => array('tl_module_movie', 'getMovieArchives'),
	'eval'                    => array('multiple'=>true, 'mandatory'=>true),
	'sql'                     => "blob NULL"
);
$GLOBALS['TL_DCA']['tl_module']['fields']['movie_featured'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_featured'],
	'default'                 => 'all_items',
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'                 => array('all_items', 'featured', 'unfeatured'),
	'reference'               => &$GLOBALS['TL_LANG']['tl_module'],
	'eval'                    => array('tl_class'=>'w50'),
	'sql'                     => "varchar(16) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movie_jumpToCurrent'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_jumpToCurrent'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'                 => array('hide_module', 'show_current', 'all_items'),
	'reference'               => &$GLOBALS['TL_LANG']['tl_module'],
	'eval'                    => array('tl_class'=>'w50'),
	'sql'                     => "varchar(16) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movie_readerModule'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_readerModule'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'        => array('tl_module_movie', 'getReaderModules'),
	'reference'               => &$GLOBALS['TL_LANG']['tl_module'],
	'eval'                    => array('includeBlankOption'=>true, 'tl_class'=>'w50'),
	'sql'                     => "int(10) unsigned NOT NULL default '0'"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movie_template'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_template'],
	'default'                 => 'movie_simple',
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'        => array('tl_module_movie', 'getMovieTemplates'),
	'eval'                    => array('tl_class'=>'w50'),
	'sql'                     => "varchar(32) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movie_showQuantity'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_showQuantity'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'sql'                     => "char(1) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['sortBy'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['sortBy'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'                 => array('movie_name_asc', 'movie_name_desc', 'year_asc', 'year_desc', 'rating_asc', 'rating_desc', 'imdb_asc', 'imdb_desc', 'random'),
	'reference'               => &$GLOBALS['TL_LANG']['tl_module'],
	'eval'                    => array('tl_class'=>'w50'),
	'sql'                     => "varchar(255) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movie_filter'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movie_filter'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
  'options'									=> array('genre' => 'Genre-Filter','actor' => 'Schauspieler-Filter','sortable' => 'Sortierbar','searchable' => 'Durchsuchbar'),
	'eval'                    => array('multiple'=>true, 'tl_class'=>'w50'),
	'sql'                     => "text NULL"
);

$GLOBALS['TL_DCA']['tl_module']['fields']['movierelated_template'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_module']['movierelated_template'],
	'default'                 => 'movie_simple',
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'        => array('tl_module_movie', 'getRelatedTemplates'),
	'eval'                    => array('tl_class'=>'w50'),
	'sql'                     => "varchar(32) NOT NULL default ''"
);


class tl_module_movie extends Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('BackendUser', 'User');
	}

	/**
	 * Get all movie archives and return them as array
	 * @return array
	 */
	public function getMovieArchives()
	{
		if (!$this->User->isAdmin && !is_array($this->User->movie))
		{
			return array();
		}

		$arrArchives = array();
		$objArchives = $this->Database->execute("SELECT id, title FROM tl_movie_archive ORDER BY title");

		while ($objArchives->next())
		{
			if ($this->User->isAdmin || $this->User->hasAccess($objArchives->id, 'movie'))
			{
				$arrArchives[$objArchives->id] = $objArchives->title;
			}
		}

		return $arrArchives;
	}


	/**
	 * Get all movie reader modules and return them as array
	 * @return array
	 */
	public function getReaderModules()
	{
		$arrModules = array();
		$objModules = $this->Database->execute("SELECT m.id, m.name, t.name AS theme FROM tl_module m LEFT JOIN tl_theme t ON m.pid=t.id WHERE m.type='moviereader' ORDER BY t.name, m.name");

		while ($objModules->next())
		{
			$arrModules[$objModules->theme][$objModules->id] = $objModules->name . ' (ID ' . $objModules->id . ')';
		}

		return $arrModules;
	}

	/**
	 * Return all movie templates as array
	 * @return array
	 */
	public function getMovieTemplates()
	{
		return $this->getTemplateGroup('movie_');
	}

	/**
	 * Return all movie related templates as array
	 * @return array
	 */
	public function getRelatedTemplates()
	{
		return $this->getTemplateGroup('mod_movierelated');
	}
}
