<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2014 Leo Feyer
 *
 * @package   movie_list
 * @author    Fast End Media | Christian Schmidt <schmidt@fast-end-media.de>
 * @license   LGPL
 * @copyright Fast End Media 2014 <http://www.fast-end-media.de>
 */

$strTable = 'tl_movie';

/**
 * Table tl_movie
 */
$GLOBALS['TL_DCA'][$strTable] = array
(

	// Config
	'config' => array
	(
		'dataContainer'					=> 'Table',
		'ptable'											=> 'tl_movie_archive',
		'switchToEdit'								=> true,
		'enableVersioning'						=> true,
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary',
				'pid' => 'index',
				'alias' => 'index'
			)
		)
	),

	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'							=> 2,
			'fields'						=> array('name'),
			'headerFields'			=> array('name', 'jumpTo', 'tstamp', 'protected', 'allowComments'),
			'panelLayout'				=> 'filter;sort,search,limit'
		),
		'label' => array
		(
			'fields'						=> array('name','year','rating'),
			'format'						=> '%s'
		),
		'global_operations' => array
		(
			'all' => array
			(
				'label'						=> &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'						=> 'act=select',
				'class'						=> 'header_edit_all',
				'attributes'			=> 'onclick="Backend.getScrollOffset();" accesskey="e"'
			)
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['edit'],
				'href'						=> 'act=edit',
				'icon'						=> 'edit.gif'
			),
			'copy' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['copy'],
				'href'						=> 'act=copy',
				'icon'						=> 'copy.gif'
			),
			'cut' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['cut'],
				'href'						=> 'act=paste&amp;mode=cut',
				'icon'						=> 'cut.gif'
			),
			'delete' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['delete'],
				'href'						=> 'act=delete',
				'icon'						=> 'delete.gif',
				'attributes'			=> 'onclick="if(!confirm(\'' . $GLOBALS['TL_LANG']['MSC']['deleteConfirm'] . '\'))return false;Backend.getScrollOffset()"'
			),
			'toggle' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['toggle'],
				'icon'						=> 'visible.gif',
				'attributes'			=> 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleVisibility(this,%s)"',
				'button_callback'	=> array($strTable, 'toggleIcon')
			),
			'feature' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['feature'],
				'icon'						=> 'featured.gif',
				'attributes'			=> 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleFeatured(this,%s)"',
				'button_callback'	=> array($strTable, 'iconFeatured')
			),
			'show' => array
			(
				'label'						=> &$GLOBALS['TL_LANG'][$strTable]['show'],
				'href'						=> 'act=show',
				'icon'						=> 'show.gif'
			)
		)
	),

	// Edit
	'edit' => array
	(
		'buttons_callback' => array()
	),

	// Palettes
	'palettes' => array
	(
		'default'							=> '{title_legend},name,alias;{info_legend},year,genre,actor,teaser;{rating_legend:hide},date,rating,imdb,review;{link_legend:hide},wikipedia,youtube,amazon,amazon2;{expert_legend:hide},cssClass,featured;{publish_legend},published,start,stop'
	),

	// Fields
	'fields' => array
	(
		'id' => array
		(
			'sql'								=> "int(10) unsigned NOT NULL auto_increment"
		),
		'pid' => array
		(
			'foreignKey'				=> 'tl_movie_archive.title',
			'sql'								=> "int(10) unsigned NOT NULL default '0'",
			'relation'					=> array('type'=>'belongsTo', 'load'=>'eager')
		),
		'tstamp' => array
		(
			'sql'								=> "int(10) unsigned NOT NULL default '0'",
			'sorting'						=> true,
			'flag'							=> 8
		),
		'name' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['name'],
			'exclude'						=> true,
			'search'						=> true,
			'sorting'						=> true,
			'flag'							=> 1,
			'inputType'					=> 'text',
			'eval'							=> array('mandatory'=>true, 'maxlength'=>255, 'tl_class'=>'w50'),
			'sql'								=> "varchar(255) NOT NULL default ''"
		),
		'alias' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['alias'],
			'exclude'						=> true,
			'search'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('rgxp'=>'alias', 'unique'=>true, 'maxlength'=>128, 'tl_class'=>'w50'),
			'save_callback'			=> array
			(
				array($strTable, 'generateAlias')
			),
			'sql'								=> "varbinary(128) NOT NULL default ''"
		),
		'teaser' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['teaser'],
			'exclude'						=> true,
			'search'						=> true,
			'inputType'					=> 'textarea',
			'load_callback'			=> array(
				array($strTable, 'getValue')
			),
			'eval'							=> array('rte'=>'tinyMCE', 'alwaysSave'=>true, 'tl_class'=>'clr'),
			'sql'								=> "text NULL"
		),
		'genre' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['genre'],
			'default'						=> BackendUser::getInstance()->id,
			'exclude'						=> true,
			'filter'						=> true,
			'sorting'						=> true,
			'flag'							=> 11,
			'inputType'					=> 'select',
			'foreignKey'				=> 'tl_movie_genre.name',
			'eval'							=> array('doNotCopy'=>true, 'chosen'=>true, 'includeBlankOption'=>true, 'tl_class'=>'w50'),
			'sql'								=> "int(10) unsigned NOT NULL default '0'",
			'relation'					=> array('type'=>'hasOne', 'load'=>'eager')
		),
		'year' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['year'],
			'sorting'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('includeBlankOption' => true, 'rgxp'=>'digit', 'tl_class'=>'w50'),
			'sql'								=> "smallint(4) unsigned NOT NULL default '0'"
		),
		'date' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['date'],
			'value'             => time(),
			'exclude'						=> true,
			'sorting'						=> true,
			'flag'							=> 8,
			'inputType'					=> 'text',
			'eval'							=> array('rgxp'=>'date', 'doNotCopy'=>true, 'datepicker'=>true, 'tl_class'=>'clr w50', 'feViewable'=>true),
			'sql'								=> "int(10) NOT NULL default '0'"
		),
		'imdb' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['imdb'],
			'sorting'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('includeBlankOption' => true, 'rgxp'=>'digit', 'tl_class'=>'w50'),
			'sql'								=> "tinyint(2) unsigned NOT NULL default '0'"
		),
		'rating' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['rating'],
			'sorting'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('includeBlankOption' => true, 'rgxp'=>'digit', 'tl_class'=>'w50'),
			'sql'								=> "tinyint(2) unsigned NOT NULL default '0'"
		),
		'review' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['review'],
			'exclude'						=> true,
			'search'						=> true,
			'inputType'					=> 'textarea',
			'eval'							=> array('rte'=>'tinyMCE', 'tl_class'=>'clr'),
			'sql'								=> "text NULL"
		),
		'wikipedia' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['wikipedia'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'load_callback'			=> array(
				array($strTable, 'getValue')
			),
			'eval'							=> array('tl_class'=>'w50', 'alwaysSave'=>true),
			'sql'								=> "varchar(64) NOT NULL default ''"
		),
		'amazon' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['amazon'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('tl_class'=>'w50'),
			'sql'								=> "varchar(64) NOT NULL default ''"
		),
		'amazon2' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['amazon2'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('tl_class'=>'w50'),
			'sql'								=> "varchar(64) NOT NULL default ''"
		),
		'youtube' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['youtube'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('tl_class'=>'w50'),
			'sql'								=> "varchar(64) NOT NULL default ''"
		),
		'actor' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['actor'],
			'exclude'						=> true,
			'inputType'					=> 'checkbox',
			'foreignKey'				=> 'tl_movie_actor.name',
			'eval'							=> array('multiple'=>true),
			'sql'								=> "text NULL"
		),
		'cssClass' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['cssClass'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'sql'								=> "varchar(255) NOT NULL default ''"
		),
		'featured' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['featured'],
			'exclude'						=> true,
			'filter'						=> true,
			'inputType'					=> 'checkbox',
			'sql'								=> "char(1) NOT NULL default ''"
		),
		'published' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['published'],
			'exclude'						=> true,
			'filter'						=> true,
			'flag'							=> 1,
			'inputType'					=> 'checkbox',
			'eval'							=> array('doNotCopy'=>true),
			'sql'								=> "char(1) NOT NULL default ''"
		),
		'start' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['start'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('rgxp'=>'datim', 'datepicker'=>true, 'tl_class'=>'w50 wizard'),
			'sql'								=> "varchar(10) NOT NULL default ''"
		),
		'stop' => array
		(
			'label'							=> &$GLOBALS['TL_LANG'][$strTable]['stop'],
			'exclude'						=> true,
			'inputType'					=> 'text',
			'eval'							=> array('rgxp'=>'datim', 'datepicker'=>true, 'tl_class'=>'w50 wizard'),
			'sql'								=> "varchar(10) NOT NULL default ''"
		)
	)
);


/**
 * Class tl_movie
 *
 * Provide miscellaneous methods that are used by the data configuration array.
 * @copyright	Leo Feyer 2005-2013
 * @authorLeo Feyer <https://contao.org>
 * @package		News
 */
class tl_movie extends Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('BackendUser', 'User');
	}

	/**
	 * Auto-generate the movie alias if it has not been set yet
	 * @param mixed
	 * @param \DataContainer
	 * @return string
	 * @throws \Exception
	 */
	public function generateAlias($varValue, DataContainer $dc)
	{
		$autoAlias = false;

		// Generate alias if there is none
		if ($varValue == '')
		{
			$autoAlias = true;
			$varValue = standardize(String::restoreBasicEntities($dc->activeRecord->name));
		}

		$objAlias = $this->Database->prepare("SELECT id FROM tl_movie WHERE alias=?")
							->execute($varValue);

		// Check whether the movie alias exists
		if ($objAlias->numRows > 1 && !$autoAlias)
		{
			throw new Exception(sprintf($GLOBALS['TL_LANG']['ERR']['aliasExists'], $varValue));
		}

		// Add ID to alias
		if ($objAlias->numRows && $autoAlias)
		{
			$varValue .= '-' . $dc->id;
		}

		return $varValue;
	}


	/**
	 * Get all articles and return them as array
	 * @param \DataContainer
	 * @return array
	 */
	public function getArticleAlias(DataContainer $dc)
	{
		$arrPids = array();
		$arrAlias = array();

		if (!$this->User->isAdmin)
		{
			foreach ($this->User->pagemounts as $id)
			{
				$arrPids[] = $id;
				$arrPids = array_merge($arrPids, $this->Database->getChildRecords($id, 'tl_page'));
			}

			if (empty($arrPids))
			{
				return $arrAlias;
			}

			$objAlias = $this->Database->prepare("SELECT a.id, a.title, a.inColumn, p.title AS parent FROM tl_article a LEFT JOIN tl_page p ON p.id=a.pid WHERE a.pid IN(". implode(',', array_map('intval', array_unique($arrPids))) .") ORDER BY parent, a.sorting")
								->execute($dc->id);
		}
		else
		{
			$objAlias = $this->Database->prepare("SELECT a.id, a.title, a.inColumn, p.title AS parent FROM tl_article a LEFT JOIN tl_page p ON p.id=a.pid ORDER BY parent, a.sorting")
								->execute($dc->id);
		}

		if ($objAlias->numRows)
		{
			System::loadLanguageFile('tl_article');

			while ($objAlias->next())
			{
				$arrAlias[$objAlias->parent][$objAlias->id] = $objAlias->title . ' (' . ($GLOBALS['TL_LANG']['tl_article'][$objAlias->inColumn] ?: $objAlias->inColumn) . ', ID ' . $objAlias->id . ')';
			}
		}

		return $arrAlias;
	}

	/**
	 * Return the link picker wizard
	 * @param \DataContainer
	 * @return string
	 */
	public function pagePicker(DataContainer $dc)
	{
		return ' <a href="contao/page.php?do='.Input::get('do').'&amp;table='.$dc->table.'&amp;field='.$dc->field.'&amp;value='.str_replace(array('{{link_url::', '}}'), '', $dc->value).'" onclick="Backend.getScrollOffset();Backend.openModalSelector({\'width\':765,\'title\':\''.specialchars(str_replace("'", "\\'", $GLOBALS['TL_LANG']['MOD']['page'][0])).'\',\'url\':this.href,\'id\':\''.$dc->field.'\',\'tag\':\'ctrl_'.$dc->field . ((Input::get('act') == 'editAll') ? '_' . $dc->id : '').'\',\'self\':this});return false">' . Image::getHtml('pickpage.gif', $GLOBALS['TL_LANG']['MSC']['pagepicker'], 'style="vertical-align:top;cursor:pointer"') . '</a>';
	}

	/**
	 * Return the "feature/unfeature element" button
	 * @param array
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @return string
	 */
	public function iconFeatured($row, $href, $label, $title, $icon, $attributes)
	{
		if (strlen(Input::get('fid')))
		{
			$this->toggleFeatured(Input::get('fid'), (Input::get('state') == 1));
			$this->redirect($this->getReferer());
		}

		// Check permissions AFTER checking the fid, so hacking attempts are logged
		if (!$this->User->isAdmin && !$this->User->hasAccess('tl_movie::featured', 'alexf'))
		{
			return '';
		}

		$href .= '&amp;fid='.$row['id'].'&amp;state='.($row['featured'] ? '' : 1);

		if (!$row['featured'])
		{
			$icon = 'featured_.gif';
		}

		return '<a href="'.$this->addToUrl($href).'" title="'.specialchars($title).'"'.$attributes.'>'.Image::getHtml($icon, $label).'</a> ';
	}


	/**
	 * Feature/unfeature a movie item
	 * @param integer
	 * @param boolean
	 * @return string
	 */
	public function toggleFeatured($intId, $blnVisible)
	{
		// Check permissions to edit
		Input::setGet('id', $intId);
		Input::setGet('act', 'feature');
		$this->checkPermission();

		// Check permissions to feature
		if (!$this->User->isAdmin && !$this->User->hasAccess('tl_movie::featured', 'alexf'))
		{
			$this->log('Not enough permissions to feature/unfeature movie item ID "'.$intId.'"', 'tl_movie toggleFeatured', TL_ERROR);
			$this->redirect('contao/main.php?act=error');
		}

		$objVersions = new Versions('tl_movie', $intId);
		$objVersions->initialize();

		// Trigger the save_callback
		if (is_array($GLOBALS['TL_DCA']['tl_movie']['fields']['featured']['save_callback']))
		{
			foreach ($GLOBALS['TL_DCA']['tl_movie']['fields']['featured']['save_callback'] as $callback)
			{
				$this->import($callback[0]);
				$blnVisible = $this->$callback[0]->$callback[1]($blnVisible, $this);
			}
		}

		// Update the database
		$this->Database->prepare("UPDATE tl_movie SET tstamp=". time() .", featured='" . ($blnVisible ? 1 : '') . "' WHERE id=?")
				->execute($intId);

		$objVersions->create();
		$this->log('A new version of record "tl_movie.id='.$intId.'" has been created'.$this->getParentEntries('tl_movie', $intId), 'tl_movie toggleFeatured()', TL_GENERAL);
	}


	/**
	 * Return the "toggle visibility" button
	 * @param array
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @return string
	 */
	public function toggleIcon($row, $href, $label, $title, $icon, $attributes)
	{
		if (strlen(Input::get('tid')))
		{
			$this->toggleVisibility(Input::get('tid'), (Input::get('state') == 1));
			$this->redirect($this->getReferer());
		}

		// Check permissions AFTER checking the tid, so hacking attempts are logged
		if (!$this->User->isAdmin && !$this->User->hasAccess('tl_movie::published', 'alexf'))
		{
			return '';
		}

		$href .= '&amp;tid='.$row['id'].'&amp;state='.($row['published'] ? '' : 1);

		if (!$row['published'])
		{
			$icon = 'invisible.gif';
		}

		return '<a href="'.$this->addToUrl($href).'" title="'.specialchars($title).'"'.$attributes.'>'.Image::getHtml($icon, $label).'</a> ';
	}


	/**
	 * Disable/enable a user group
	 * @param integer
	 * @param boolean
	 */
	public function toggleVisibility($intId, $blnVisible)
	{
		// Check permissions to edit
		Input::setGet('id', $intId);
		Input::setGet('act', 'toggle');
		$this->checkPermission();

		// Check permissions to publish
		if (!$this->User->isAdmin && !$this->User->hasAccess('tl_movie::published', 'alexf'))
		{
			$this->log('Not enough permissions to publish/unpublish movie item ID "'.$intId.'"', 'tl_movie toggleVisibility', TL_ERROR);
			$this->redirect('contao/main.php?act=error');
		}

		$objVersions = new Versions('tl_movie', $intId);
		$objVersions->initialize();

		// Trigger the save_callback
		if (is_array($GLOBALS['TL_DCA']['tl_movie']['fields']['published']['save_callback']))
		{
			foreach ($GLOBALS['TL_DCA']['tl_movie']['fields']['published']['save_callback'] as $callback)
			{
				$this->import($callback[0]);
				$blnVisible = $this->$callback[0]->$callback[1]($blnVisible, $this);
			}
		}

		// Update the database
		$this->Database->prepare("UPDATE tl_movie SET tstamp=". time() .", published='" . ($blnVisible ? 1 : '') . "' WHERE id=?")
				->execute($intId);

		$objVersions->create();
		$this->log('A new version of record "tl_movie.id='.$intId.'" has been created'.$this->getParentEntries('tl_movie', $intId), 'tl_movie toggleVisibility()', TL_GENERAL);

	}

	/**
	 * Add a link to the list items import wizard
	 * @return string
	 */
	public function listImportWizard()
	{
		return ' <a href="' . $this->addToUrl('key=list') . '" title="' . specialchars($GLOBALS['TL_LANG']['MSC']['lw_import'][1]) . '" onclick="Backend.getScrollOffset()">' . Image::getHtml('tablewizard.gif', $GLOBALS['TL_LANG']['MSC']['tw_import'][0], 'style="vertical-align:text-bottom"') . '</a>';
	}


	public function getValue($strValue, $dc)
	{
    $field = $dc->field;
		if(!$strValue) {
			if($field == 'teaser') {
				if($dc->activeRecord->wikipedia) {
					$strKeyword = $dc->activeRecord->wikipedia;
				}
				else {
					$strKeyword = str_replace(' ', '_', $dc->activeRecord->name);
				}

	  		$this->import('MovieHelper', 'Helper');
	      $strValue = $this->Helper->getWikipediaContent($strKeyword);
			}
			elseif($field == 'wikipedia') {
				if($dc->activeRecord->name) {
					$strValue = str_replace(' ', '_', $dc->activeRecord->name);
				}
			}
		}
    return $strValue;
	}
}
