<?php
/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2014 Leo Feyer
 *
 * @package   movie_list
 * @author    Fast End Media | Christian Schmidt <schmidt@fast-end-media.de>
 * @license   LGPL
 * @copyright Fast End Media 2014 <http://www.fast-end-media.de>
 */
/**
 * Run in a custom namespace, so the class can be replaced
 */
namespace Contao;
class ModuleMovieRelated extends \ModuleMovie
{
	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'mod_movierelated';
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$objTemplate = new BackendTemplate('be_wildcard');
			$objTemplate->wildcard = '### ' . utf8_strtoupper($GLOBALS['TL_LANG']['FMD']['movierelated'][0]) . ' ###';
			$objTemplate->title = $this->headline;
			$objTemplate->id = $this->id;
			$objTemplate->link = $this->name;
			$objTemplate->href = 'contao/main.php?do=modules&amp;act=edit&amp;id=' . $this->id;
			return $objTemplate->parse();
		}
		$this->movie_archives = $this->sortOutProtected(deserialize($this->movie_archives));

		// Return if there are no archives
		if (!is_array($this->movie_archives) || empty($this->movie_archives))
		{
			return '';
		}
		return parent::generate();
	}

	/**
	 * Generate module
	 */
	protected function compile()
	{
		$arrOptions = null;
    //limit
		if($this->related_numberOfItems >= 0 && $this->related_numberOfItems <= 50) {
			$limit = $this->related_numberOfItems;
		}
		else {
			$limit = 4;
		}

    $this->Template->info = $GLOBALS['TL_LANG']['MSC']['relatedInfo'];
		if(\Input::get('auto_item')) { $movie_alias = \Input::get('auto_item'); }
		else { $movie_alias = \Input::get('items'); }

		//Find out sorting
		if (\Input::get('order_by'))
		{
      $getSortBy = \Input::get('order_by');
		}

		if($this->sortBy) {
      $t = 'tl_movie';
			if($this->sortBy == 'movie_name_asc' && !$getSortBy || $getSortBy == 'movie_name_asc') { $sortBy = "$t.name ASC"; }
			elseif($this->sortBy == 'movie_name_desc' && !$getSortBy || $getSortBy == 'movie_name_desc') { $sortBy = "$t.name DESC"; }
      elseif($this->sortBy == 'year_asc' && !$getSortBy || $getSortBy == 'year_asc') { $sortBy = "$t.year ASC"; }
			elseif($this->sortBy == 'year_desc' && !$getSortBy || $getSortBy == 'year_desc') { $sortBy = "$t.year DESC"; }
      elseif($this->sortBy == 'rating_asc' && !$getSortBy || $getSortBy == 'rating_asc') { $sortBy = "$t.rating ASC"; }
			elseif($this->sortBy == 'rating_desc' && !$getSortBy || $getSortBy == 'rating_desc') { $sortBy = "$t.rating DESC"; }
      elseif($this->sortBy == 'imdb_asc' && !$getSortBy || $getSortBy == 'imdb_asc') { $sortBy = "$t.imdb ASC"; }
			elseif($this->sortBy == 'imdb_desc' && !$getSortBy || $getSortBy == 'imdb_desc') { $sortBy = "$t.imdb DESC"; }
      else { $sortBy = "rand()"; }
			$arrOptions['order']  = $sortBy;
		}

		//Aktuelles Archiv auslesen
    $objMovie = $this->Database->prepare("SELECT pid,genre FROM tl_movie WHERE id=? OR alias=?")->execute($movie_alias,$movie_alias);

		// Get the items
		if(isset($objMovie->genre)) {
      $objArticles = \MovieModel::findPublishedByGenre($objMovie->genre, $limit, $arrOptions);
		}
		else {
			$objArticles = \MovieModel::findPublishedByPid($objMovie->pid, $limit, $arrOptions);
		}

		// No items found
		if ($objArticles === null)
		{
			$this->Template = new \FrontendTemplate('mod_movie_empty');
			$this->Template->empty = $GLOBALS['TL_LANG']['MSC']['emptyList'];
		}
		else
		{
			$this->Template->articles = $this->parseArticles($objArticles);
		}
		$this->Template->archives = $this->movie_archives;
	}
}
?>
