<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (c) 2005-2014 Leo Feyer
 *
 * @package   movie_list
 * @author    Fast End Media | Christian Schmidt <schmidt@fast-end-media.de>
 * @license   LGPL
 * @copyright Fast End Media 2014 <http://www.fast-end-media.de>
 */


class ModuleMovieSearch extends Module
{
	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'mod_moviesearch';
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$objTemplate = new BackendTemplate('be_wildcard');
			$objTemplate->wildcard = '### ' . utf8_strtoupper($GLOBALS['TL_LANG']['FMD']['moviesearch'][0]) . ' ###';
			$objTemplate->title = $this->headline;
			$objTemplate->id = $this->id;
			$objTemplate->link = $this->name;
			$objTemplate->href = 'contao/main.php?do=modules&amp;act=edit&amp;id=' . $this->id;
			return $objTemplate->parse();
		}
		$this->movie_archives = deserialize($this->movie_archives);
		// Return if there are no archives
		if (!is_array($this->movie_archives) || empty($this->movie_archives))
		{
			return '';
		}
		return parent::generate();
	}

 /**
	 * Generate module
	 */
	protected function compile()
	{
  	$this->loadLanguageFile('tl_movie');
		$this->loadDataContainer('tl_movie');
		if($autocompleter) {
			//Autocompleter
			$objAutoCompleter = new AutoCompleter();
			$objAutoCompleter->formId = 'ctrl_for';
			$objAutoCompleter->minLength = '1';
			$objAutoCompleter->width = 'inherit';
			$objAutoCompleter->maxChoices = '10';
			$objAutoCompleter->zIndex = '35';
			$objAutoCompleter->delay = '400';
			$objAutoCompleter->generate();
		}

		//Current page link
    global $objPage;
		$intId = $objPage->id;
		if (($jumpTo = \PageModel::findByPk($intId)) !== null) {
		   $this->Template->self_link = \Controller::generateFrontendUrl($jumpTo->row());
		} else {
		   // Die Seite mit ID $myId wurde nicht gefunden
		}

		/**
		 * Add the search menu
		 */
		$strOptions = '';
		$this->Template->searchable = false;
		$arrFilter = deserialize($this->movie_filter);
		if (!empty($arrFilter) && is_array($arrFilter))
		{
			foreach($arrFilter as $filter) {
				if($filter == 'genre') { $this->Template->genre_filter = true; }
				elseif($filter == 'actor') { $this->Template->actor_filter = true; }
	      elseif($filter == 'sortable') { $this->Template->sortable = true; }
	      elseif($filter == 'searchable') { $this->Template->searchable = true; }
			}
		}

		//$arrSortFields = trimsplit(',', $this->list_sort);
		if ($this->Template->sortable)
		{
			$this->Template->sort_label = specialchars($GLOBALS['TL_LANG']['tl_movie']['sort_label']);
      $this->Template->sort_label_option = specialchars($GLOBALS['TL_LANG']['tl_movie']['sort_label_option']);
      $url = $this->Environment->requestUri;
			$base_url = strstr($url, '?', true);
			$var_url = strstr($url, '?');
			$suchmuster = array('/[&|?]sort=[a-z0-9-_]*/i','/[&|?]order_by=[a-z0-9-_]*/i','/\?/i');
			$ersetzung = array('','','&');
			$var_url = preg_replace($suchmuster, $ersetzung, $var_url);
			//$url = str_replace('')
			if(stristr($url,'?')) { $url .= '&'; } else { $url .= '?'; }
			foreach ($GLOBALS['TL_DCA']['tl_module']['fields']['sortBy']['options'] as $field)
			{
        $value = $url.'order_by='.$field;
				$strOptions .= '  <option value="' . $value . '"' . (($field == \Input::get('order_by')) ? ' selected="selected"' : '') . '>' . (strlen($label = $GLOBALS['TL_LANG']['tl_module'][$field]) ? $label : $option) . '</option>' . "\n";
			}
      $this->Template->sort_fields = $strOptions;
		}
		if($this->Template->actor_filter) {
      $this->Template->actor = \MovieActorModel::findAll();
      $this->Template->actor_label = $GLOBALS['TL_LANG']['tl_movie']['actor'][0];
      $this->Template->actor_label_option = specialchars($GLOBALS['TL_LANG']['tl_movie']['actor_label_option']);
		}
		if($this->Template->genre_filter) {
      $this->Template->genre = \MovieGenreModel::findAll();
      $this->Template->genre_label = $GLOBALS['TL_LANG']['tl_movie']['genre'][0];
      $this->Template->genre_label_option = specialchars($GLOBALS['TL_LANG']['tl_movie']['genre_label_option']);
		}

		/**
		 * Template variables
		 */
		//Weiterleitung
		if (($jumpTo = \PageModel::findByPk($this->jumpTo)) !== null) {
		   $strUrl = \Controller::generateFrontendUrl($jumpTo->row());
		} else {
		   $strUrl = \Environment::get('indexFreeRequest');
		}

		$this->Template->action = $strUrl;
		$this->Template->details = ($this->list_info != '') ? true : false;
		$this->Template->search_label = specialchars($GLOBALS['TL_LANG']['tl_movie']['search_label']);
    $this->Template->search_label_submit = specialchars($GLOBALS['TL_LANG']['tl_movie']['search_label_submit']);

		//Formulareinstellungen zurücksetzen?
		if(stristr($this->Environment->requestUri,'?')) {
	    $this->Template->abort_label = specialchars($GLOBALS['TL_LANG']['tl_movie']['abort_label']);
	    $this->Template->abort_link = strstr($this->Environment->request,'?',true);
		}

		$this->Template->search = \Input::get('search');
		$this->Template->order_by = \Input::get('order_by');
		$this->Template->sort = \Input::get('sort');
		$this->Template->col_last = 'col_' . $j;
	}
}
